Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon
Class TransformerFactoryImpl

    java.lang.Object
      javax.xml.transform.TransformerFactory
          javax.xml.transform.sax.SAXTransformerFactory
              net.sf.saxon.TransformerFactoryImpl

Direct Known Subclasses:
  SchemaAwareTransformerFactory

    public class TransformerFactoryImpl

extends SAXTransformerFactory

A TransformerFactoryImpl instance can be used to create Transformer and Template objects.

The system property that determines which Factory implementation to create is named "javax.xml.transform.TransformerFactory". This property names a concrete subclass of the TransformerFactory abstract class. If the property is not defined, a platform default is be used.

This implementation class implements the abstract methods on both the javax.xml.transform.TransformerFactory and javax.xml.transform.sax.SAXTransformerFactory classes.

Field Summary

Fields inherited from class javax.xml.transform.sax.SAXTransformerFactory
`FEATURE, FEATURE_XMLFILTER`

Constructor Summary
`TransformerFactoryImpl()` Default constructor.
`TransformerFactoryImpl(Configuration config)` Construct a TransformerFactory using an existing Configuration.

Method Summary
`Source` | `getAssociatedStylesheet(Source source, String media, String title, String charset)` Get the stylesheet specification(s) associated via the xml-stylesheet processing instruction (see http://www.w3.org/TR/xml-stylesheet/) with the document document specified in the source parameter, and that match the given criteria.
`Object` | `getAttribute(String name)` Allows the user to retrieve specific attributes on the underlying implementation.
`Configuration` | `getConfiguration()` Get the configuration.
`ErrorListener` | `getErrorListener()` Get the error event handler for the TransformerFactory.
`boolean` | `getFeature(String name)` Look up the value of a feature.
`URIResolver` | `getURIResolver()` Get the object that is used by default during the transformation to resolve URIs used in document(), xsl:import, or xsl:include.
`Templates` | `newTemplates(Source source)` Process the Source into a Templates object, which is a a compiled representation of the source.
`Templates` | `newTemplates(Source source, CompilerInfo info)` Process the Source into a Templates object, which is a a compiled representation of the source.
`TemplatesHandler` | `newTemplatesHandler()` Get a TemplatesHandler object that can process SAX ContentHandler events into a Templates object.
`Transformer` | `newTransformer()` Create a new Transformer object that performs a copy of the source to the result.
`Transformer` | `newTransformer(Source source)` Process the Source into a Transformer object.
`TransformerHandler` | `newTransformerHandler()` Get a TransformerHandler object that can process SAX ContentHandler events into a Result.
`TransformerHandler` | `newTransformerHandler(Source src)` Get a TransformerHandler object that can process SAX ContentHandler events into a Result, based on the transformation instructions specified by the argument.
`TransformerHandler` | `newTransformerHandler(Templates templates)` Get a TransformerHandler object that can process SAX ContentHandler events into a Result, based on the Templates argument.
`XMLFilter` | `newXMLFilter(Source src)` Create an XMLFilter that uses the given Source as the transformation instructions.
`XMLFilter` | `newXMLFilter(Templates templates)` Create an XMLFilter, based on the Templates argument..
`void` | `setAttribute(String name, Object value)` Allows the user to set specific attributes on the underlying implementation.
`void` | `setConfiguration(Configuration config)` Set the configuration.
`void` | `setErrorListener(ErrorListener listener)` Set the error event listener for the TransformerFactory, which is used for the processing of transformation instructions, and not for the transformation itself.
`void` | `setFeature(String name, boolean value)` Set a feature for this `TransformerFactory` and `Transformer`s or `Template`s created by this factory.
`void` | `setURIResolver(URIResolver resolver)` Set an object that is used by default during the transformation to resolve URIs used in xsl:import, or xsl:include.

Methods inherited from class javax.xml.transform.TransformerFactory
`newInstance`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### TransformerFactoryImpl

    public TransformerFactoryImpl()

  Default constructor.

### TransformerFactoryImpl

    public TransformerFactoryImpl(Configuration config)

  Construct a TransformerFactory using an existing Configuration.

Method Detail

### setConfiguration

    public void setConfiguration(Configuration config)

  Set the configuration. This can also be done using the JAXP method setAttribute, with the attribute name `FeatureKeys.CONFIGURATION`

### getConfiguration

    public Configuration getConfiguration()

  Get the configuration. This can also be done using the JAXP method getAttribute, with the attribute name `FeatureKeys.CONFIGURATION`

### newTransformer

    public Transformer newTransformer(Source source)
                               throws TransformerConfigurationException

  Process the Source into a Transformer object. Care must be given not to use this object in multiple threads running concurrently. Different TransformerFactories can be used concurrently by different threads.

  Specified by:
    `newTransformer` in class `TransformerFactory`
  Parameters:
    `source` - An object that holds a URI, input stream, etc.
  Returns:
    A Transformer object that may be used to perform a transformation in a single thread, never null.
  Throws:
    `TransformerConfigurationException` - May throw this during the parse when it is constructing the Templates object and fails.

### newTransformer

    public Transformer newTransformer()
                               throws TransformerConfigurationException

  Create a new Transformer object that performs a copy of the source to the result.

  Specified by:
    `newTransformer` in class `TransformerFactory`
  Returns:
    A Transformer object that may be used to perform a transformation in a single thread, never null.
  Throws:
    `TransformerConfigurationException` - May throw this during the parse when it is constructing the Templates object and fails.

### newTemplates

    public Templates newTemplates(Source source)
                           throws TransformerConfigurationException

  Process the Source into a Templates object, which is a a compiled representation of the source. This Templates object may then be used concurrently across multiple threads. Creating a Templates object allows the TransformerFactory to do detailed performance optimization of transformation instructions, without penalizing runtime transformation.

  Specified by:
    `newTemplates` in class `TransformerFactory`
  Parameters:
    `source` - An object that holds a URL, input stream, etc.
  Returns:
    A Templates object capable of being used for transformation purposes, never null.
  Throws:
    `TransformerConfigurationException` - May throw this during the parse when it is constructing the Templates object and fails.

### newTemplates

    public Templates newTemplates(Source source,
                                  CompilerInfo info)
                           throws TransformerConfigurationException

  Process the Source into a Templates object, which is a a compiled representation of the source. This Templates object may then be used concurrently across multiple threads. Creating a Templates object allows the TransformerFactory to do detailed performance optimization of transformation instructions, without penalizing runtime transformation.

  Parameters:
    `source` - An object that holds a URL, input stream, etc.
  Returns:
    A Templates object capable of being used for transformation purposes, never null.
  Throws:
    `TransformerConfigurationException` - May throw this during the parse when it is constructing the Templates object and fails.

### getAssociatedStylesheet

    public Source getAssociatedStylesheet(Source source,
                                          String media,
                                          String title,
                                          String charset)
                                   throws TransformerConfigurationException

  Get the stylesheet specification(s) associated via the xml-stylesheet processing instruction (see http://www.w3.org/TR/xml-stylesheet/) with the document document specified in the source parameter, and that match the given criteria. Note that it is possible to return several stylesheets, in which case they are applied as if they were a list of imports or cascades.

  Specified by:
    `getAssociatedStylesheet` in class `TransformerFactory`
  Parameters:
    `source` - The XML source document.
    `media` - The media attribute to be matched. May be null, in which case the prefered templates will be used (i.e. alternate = no).
    `title` - The value of the title attribute to match. May be null.
    `charset` - The value of the charset attribute to match. May be null.
  Returns:
    A Source object suitable for passing to the TransformerFactory.
  Throws:
    `TransformerConfigurationException` - if any problems occur

### setURIResolver

    public void setURIResolver(URIResolver resolver)

  Set an object that is used by default during the transformation to resolve URIs used in xsl:import, or xsl:include.

  Specified by:
    `setURIResolver` in class `TransformerFactory`
  Parameters:
    `resolver` - An object that implements the URIResolver interface, or null.

### getURIResolver

    public URIResolver getURIResolver()

  Get the object that is used by default during the transformation to resolve URIs used in document(), xsl:import, or xsl:include.

  Specified by:
    `getURIResolver` in class `TransformerFactory`
  Returns:
    The URIResolver that was set with setURIResolver.

### getFeature

    public boolean getFeature(String name)

  Look up the value of a feature.

  The feature name is any absolute URI.

  Specified by:
    `getFeature` in class `TransformerFactory`
  Parameters:
    `name` - The feature name, which is an absolute URI.
  Returns:
    The current state of the feature (true or false).

### setAttribute

    public void setAttribute(String name,
                             Object value)
                      throws IllegalArgumentException

  Allows the user to set specific attributes on the underlying implementation. An attribute in this context is defined to be an option that the implementation provides.

  Specified by:
    `setAttribute` in class `TransformerFactory`
  Parameters:
    `name` - The name of the attribute. This must be one of the constants defined in class `FeatureKeys`.
    `value` - The value of the attribute.
  Throws:
    `IllegalArgumentException` - thrown if Saxon doesn't recognize the attribute.
  See Also:
    `FeatureKeys`

### getAttribute

    public Object getAttribute(String name)
                        throws IllegalArgumentException

  Allows the user to retrieve specific attributes on the underlying implementation.

  Specified by:
    `getAttribute` in class `TransformerFactory`
  Parameters:
    `name` - The name of the attribute.
  Returns:
    value The value of the attribute.
  Throws:
    `IllegalArgumentException` - thrown if the underlying implementation doesn't recognize the attribute.

### setErrorListener

    public void setErrorListener(ErrorListener listener)
                          throws IllegalArgumentException

  Set the error event listener for the TransformerFactory, which is used for the processing of transformation instructions, and not for the transformation itself.

  Specified by:
    `setErrorListener` in class `TransformerFactory`
  Parameters:
    `listener` - The new error listener.
  Throws:
    `IllegalArgumentException` - if listener is null.

### getErrorListener

    public ErrorListener getErrorListener()

  Get the error event handler for the TransformerFactory.

  Specified by:
    `getErrorListener` in class `TransformerFactory`
  Returns:
    The current error listener, which should never be null.

### newTransformerHandler

    public TransformerHandler newTransformerHandler(Source src)
                                             throws TransformerConfigurationException

  Get a TransformerHandler object that can process SAX ContentHandler events into a Result, based on the transformation instructions specified by the argument.

  Specified by:
    `newTransformerHandler` in class `SAXTransformerFactory`
  Parameters:
    `src` - The Source of the transformation instructions.
  Returns:
    TransformerHandler ready to transform SAX events.
  Throws:
    `TransformerConfigurationException` - If for some reason the TransformerHandler can not be created.

### newTransformerHandler

    public TransformerHandler newTransformerHandler(Templates templates)
                                             throws TransformerConfigurationException

  Get a TransformerHandler object that can process SAX ContentHandler events into a Result, based on the Templates argument.

  Specified by:
    `newTransformerHandler` in class `SAXTransformerFactory`
  Parameters:
    `templates` - The compiled transformation instructions.
  Returns:
    TransformerHandler ready to transform SAX events.
  Throws:
    `TransformerConfigurationException` - If for some reason the TransformerHandler can not be created.

### newTransformerHandler

    public TransformerHandler newTransformerHandler()
                                             throws TransformerConfigurationException

  Get a TransformerHandler object that can process SAX ContentHandler events into a Result. The transformation is defined as an identity (or copy) transformation, for example to copy a series of SAX parse events into a DOM tree.

  Specified by:
    `newTransformerHandler` in class `SAXTransformerFactory`
  Returns:
    A non-null reference to a TransformerHandler, that may be used as a ContentHandler for SAX parse events.
  Throws:
    `TransformerConfigurationException` - If for some reason the TransformerHandler cannot be created.

### newTemplatesHandler

    public TemplatesHandler newTemplatesHandler()
                                         throws TransformerConfigurationException

  Get a TemplatesHandler object that can process SAX ContentHandler events into a Templates object.

  Specified by:
    `newTemplatesHandler` in class `SAXTransformerFactory`
  Returns:
    A non-null reference to a TransformerHandler, that may be used as a ContentHandler for SAX parse events.
  Throws:
    `TransformerConfigurationException` - If for some reason the TemplatesHandler cannot be created.

### newXMLFilter

    public XMLFilter newXMLFilter(Source src)
                           throws TransformerConfigurationException

  Create an XMLFilter that uses the given Source as the transformation instructions.

  Specified by:
    `newXMLFilter` in class `SAXTransformerFactory`
  Parameters:
    `src` - The Source of the transformation instructions.
  Returns:
    An XMLFilter object, or null if this feature is not supported.
  Throws:
    `TransformerConfigurationException` - If for some reason the XMLFilter cannot be created.

### newXMLFilter

    public XMLFilter newXMLFilter(Templates templates)
                           throws TransformerConfigurationException

  Create an XMLFilter, based on the Templates argument..

  Specified by:
    `newXMLFilter` in class `SAXTransformerFactory`
  Parameters:
    `templates` - The compiled transformation instructions.
  Returns:
    An XMLFilter object, or null if this feature is not supported.
  Throws:
    `TransformerConfigurationException` - If for some reason the XMLFilter cannot be created.

### setFeature

    public void setFeature(String name,
                           boolean value)
                    throws TransformerConfigurationException

  Set a feature for this `TransformerFactory` and `Transformer`s or `Template`s created by this factory.

  Feature names are fully qualified `URI`s. Implementations may define their own features. An `TransformerConfigurationException` is thrown if this `TransformerFactory` or the `Transformer`s or `Template`s it creates cannot support the feature. It is possible for an `TransformerFactory` to expose a feature value but be unable to change its state.

  All implementations are required to support the FEATURE_SECURE_PROCESSING feature. When the feature is:

  - `true`: the implementation will limit XML processing to conform to implementation limits and behave in a secure fashion as defined by the implementation. Examples include resolving user defined style sheets and functions. If XML processing is limited for security reasons, it will be reported via a call to the registered `ErrorListener.fatalError(javax.xml.transform.TransformerException exception)`. See `setErrorListener(javax.xml.transform.ErrorListener listener)`. In the Saxon implementation, this option causes calls on extension functions and extensions instructions to be disabled, and also disables the use of xsl:result-document to write to secondary output destinations.
  - `false`: the implementation will processing XML according to the XML specifications without regard to possible implementation limits.

  Specified by:
    `setFeature` in class `TransformerFactory`
  Parameters:
    `name` - Feature name.
    `value` - Is feature state `true` or `false`.
  Throws:
    `TransformerConfigurationException` - if this `TransformerFactory` or the `Transformer`s or `Template`s it creates cannot support this feature.
    `NullPointerException` - If the `name` parameter is null.

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.